Index: /trunk/sources/HeuristicLab.FixedOperators/3.2/HeuristicLab.FixedOperators-3.2.csproj
===================================================================
--- /trunk/sources/HeuristicLab.FixedOperators/3.2/HeuristicLab.FixedOperators-3.2.csproj	(revision 1738)
+++ /trunk/sources/HeuristicLab.FixedOperators/3.2/HeuristicLab.FixedOperators-3.2.csproj	(revision 1739)
@@ -50,4 +50,36 @@
     <WarningLevel>4</WarningLevel>
   </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|x86' ">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\x86\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|x86' ">
+    <OutputPath>bin\x86\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|x64' ">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\x64\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|x64' ">
+    <OutputPath>bin\x64\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
   <ItemGroup>
     <Reference Include="System" />
Index: /trunk/sources/HeuristicLab.Security.ADODataAccess/3.2/HeuristicLab.Security.ADODataAccess-3.2.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Security.ADODataAccess/3.2/HeuristicLab.Security.ADODataAccess-3.2.csproj	(revision 1738)
+++ /trunk/sources/HeuristicLab.Security.ADODataAccess/3.2/HeuristicLab.Security.ADODataAccess-3.2.csproj	(revision 1739)
@@ -34,4 +34,36 @@
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|x86' ">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\x86\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|x86' ">
+    <OutputPath>bin\x86\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|x64' ">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\x64\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|x64' ">
+    <OutputPath>bin\x64\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
   </PropertyGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: /trunk/sources/HeuristicLab.Security.Core/3.2/HeuristicLab.Security.Core-3.2.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Security.Core/3.2/HeuristicLab.Security.Core-3.2.csproj	(revision 1738)
+++ /trunk/sources/HeuristicLab.Security.Core/3.2/HeuristicLab.Security.Core-3.2.csproj	(revision 1739)
@@ -32,4 +32,36 @@
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|x86' ">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\x86\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|x86' ">
+    <OutputPath>bin\x86\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|x64' ">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\x64\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|x64' ">
+    <OutputPath>bin\x64\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
   </PropertyGroup>
   <ItemGroup>
Index: /trunk/sources/HeuristicLab.Security.Server/3.2/HeuristicLab.Security.Server-3.2.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Security.Server/3.2/HeuristicLab.Security.Server-3.2.csproj	(revision 1738)
+++ /trunk/sources/HeuristicLab.Security.Server/3.2/HeuristicLab.Security.Server-3.2.csproj	(revision 1739)
@@ -32,4 +32,36 @@
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|x86' ">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\x86\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|x86' ">
+    <OutputPath>bin\x86\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|x64' ">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\x64\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|x64' ">
+    <OutputPath>bin\x64\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
   </PropertyGroup>
   <ItemGroup>
Index: /trunk/sources/HeuristicLab.sln
===================================================================
--- /trunk/sources/HeuristicLab.sln	(revision 1738)
+++ /trunk/sources/HeuristicLab.sln	(revision 1739)
@@ -1984,6 +1984,6 @@
 		{CE2DFB48-6A9C-4507-96C6-5FC40E92035C}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{CE2DFB48-6A9C-4507-96C6-5FC40E92035C}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{CE2DFB48-6A9C-4507-96C6-5FC40E92035C}.Debug|x64.ActiveCfg = Debug|Any CPU
-		{CE2DFB48-6A9C-4507-96C6-5FC40E92035C}.Debug|x86.ActiveCfg = Debug|Any CPU
+		{CE2DFB48-6A9C-4507-96C6-5FC40E92035C}.Debug|x64.ActiveCfg = Debug|x64
+		{CE2DFB48-6A9C-4507-96C6-5FC40E92035C}.Debug|x86.ActiveCfg = Debug|x86
 		{CE2DFB48-6A9C-4507-96C6-5FC40E92035C}.GP Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{CE2DFB48-6A9C-4507-96C6-5FC40E92035C}.GP Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -2469,6 +2469,6 @@
 		{FD1AFEC2-7A79-45CF-9365-5195B04A2C9F}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{FD1AFEC2-7A79-45CF-9365-5195B04A2C9F}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{FD1AFEC2-7A79-45CF-9365-5195B04A2C9F}.Debug|x64.ActiveCfg = Debug|Any CPU
-		{FD1AFEC2-7A79-45CF-9365-5195B04A2C9F}.Debug|x86.ActiveCfg = Debug|Any CPU
+		{FD1AFEC2-7A79-45CF-9365-5195B04A2C9F}.Debug|x64.ActiveCfg = Debug|x64
+		{FD1AFEC2-7A79-45CF-9365-5195B04A2C9F}.Debug|x86.ActiveCfg = Debug|x86
 		{FD1AFEC2-7A79-45CF-9365-5195B04A2C9F}.GP Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{FD1AFEC2-7A79-45CF-9365-5195B04A2C9F}.GP Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -2489,6 +2489,8 @@
 		{583705E2-B1F7-42B8-8149-96E7AECA171A}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{583705E2-B1F7-42B8-8149-96E7AECA171A}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{583705E2-B1F7-42B8-8149-96E7AECA171A}.Debug|x64.ActiveCfg = Debug|Any CPU
-		{583705E2-B1F7-42B8-8149-96E7AECA171A}.Debug|x86.ActiveCfg = Debug|Any CPU
+		{583705E2-B1F7-42B8-8149-96E7AECA171A}.Debug|x64.ActiveCfg = Debug|x64
+		{583705E2-B1F7-42B8-8149-96E7AECA171A}.Debug|x64.Build.0 = Debug|x64
+		{583705E2-B1F7-42B8-8149-96E7AECA171A}.Debug|x86.ActiveCfg = Debug|x86
+		{583705E2-B1F7-42B8-8149-96E7AECA171A}.Debug|x86.Build.0 = Debug|x86
 		{583705E2-B1F7-42B8-8149-96E7AECA171A}.GP Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{583705E2-B1F7-42B8-8149-96E7AECA171A}.GP Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -2869,6 +2871,6 @@
 		{E3288D4B-7A51-499A-AC5B-019319CE51DC}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{E3288D4B-7A51-499A-AC5B-019319CE51DC}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{E3288D4B-7A51-499A-AC5B-019319CE51DC}.Debug|x64.ActiveCfg = Debug|Any CPU
-		{E3288D4B-7A51-499A-AC5B-019319CE51DC}.Debug|x86.ActiveCfg = Debug|Any CPU
+		{E3288D4B-7A51-499A-AC5B-019319CE51DC}.Debug|x64.ActiveCfg = Debug|x64
+		{E3288D4B-7A51-499A-AC5B-019319CE51DC}.Debug|x86.ActiveCfg = Debug|x86
 		{E3288D4B-7A51-499A-AC5B-019319CE51DC}.GP Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{E3288D4B-7A51-499A-AC5B-019319CE51DC}.GP Debug|Any CPU.Build.0 = Debug|Any CPU