Index: /trunk/sources/HeuristicLab.Hive.Server.Console/3.2/AddJobForm.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.Console/3.2/AddJobForm.cs	(revision 1752)
+++ /trunk/sources/HeuristicLab.Hive.Server.Console/3.2/AddJobForm.cs	(revision 1753)
@@ -70,5 +70,5 @@
               foreach (Job pjob in jobGroups.List) {
                 if (cbParJob.SelectedItem.ToString().Equals(pjob.Id.ToString())) {
-                  Job job = new Job { ParentJob = pjob, State = State.offline };
+                  Job job = new Job { ParentJob = pjob, State = State.offline, CoresNeeded = 1 };
                   job.SerializedJob = PersistenceManager.SaveToGZip(new TestJob());
                   Response resp = jobManager.AddNewJob(job);
@@ -76,5 +76,5 @@
               }
             } else {
-              Job job = new Job { State = State.offline };
+              Job job = new Job { State = State.offline, CoresNeeded = 1 };
               job.SerializedJob = PersistenceManager.SaveToGZip(new TestJob());
               Response resp = jobManager.AddNewJob(job);
Index: /trunk/sources/HeuristicLab.Hive.Server.Console/3.2/HiveServerConsole.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.Console/3.2/HiveServerConsole.cs	(revision 1752)
+++ /trunk/sources/HeuristicLab.Hive.Server.Console/3.2/HiveServerConsole.cs	(revision 1753)
@@ -91,4 +91,7 @@
             Response resp = scf.Login(tbUserName.Text, tbPwd.Text);
             string str = resp.StatusMessage;
+            if (resp.StatusMessage != "Logged in") {
+              return false;
+            }
           } else {
             lblError.Text = "IP or Port not valid";
Index: /trunk/sources/HeuristicLab.Hive.Server.Console/3.2/HiveServerManagementConsole.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.Console/3.2/HiveServerManagementConsole.Designer.cs	(revision 1752)
+++ /trunk/sources/HeuristicLab.Hive.Server.Console/3.2/HiveServerManagementConsole.Designer.cs	(revision 1753)
@@ -212,4 +212,5 @@
       // 
       this.plClientDetails.BackColor = System.Drawing.SystemColors.Window;
+      this.plClientDetails.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
       this.plClientDetails.Controls.Add(this.lblState);
       this.plClientDetails.Controls.Add(this.lblStateClient);
@@ -319,4 +320,5 @@
       // 
       this.plJobDetails.BackColor = System.Drawing.SystemColors.Window;
+      this.plJobDetails.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
       this.plJobDetails.Controls.Add(this.lvSnapshots);
       this.plJobDetails.Controls.Add(this.lblPriorityJob);
@@ -438,5 +440,5 @@
       this.lblProgress.BackColor = System.Drawing.Color.Transparent;
       this.lblProgress.ImageAlign = System.Drawing.ContentAlignment.MiddleRight;
-      this.lblProgress.Location = new System.Drawing.Point(256, 108);
+      this.lblProgress.Location = new System.Drawing.Point(252, 108);
       this.lblProgress.Name = "lblProgress";
       this.lblProgress.Size = new System.Drawing.Size(143, 13);
Index: /trunk/sources/HeuristicLab.Hive.Server.Console/3.2/HiveServerManagementConsole.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.Console/3.2/HiveServerManagementConsole.cs	(revision 1752)
+++ /trunk/sources/HeuristicLab.Hive.Server.Console/3.2/HiveServerManagementConsole.cs	(revision 1753)
@@ -31,4 +31,5 @@
 using HeuristicLab.Hive.Contracts.BusinessObjects;
 using HeuristicLab.Hive.Contracts;
+using System.Threading;
 
 namespace HeuristicLab.Hive.Server.ServerConsole {
@@ -57,4 +58,5 @@
     private Job currentJob = null;
     private ClientInfo currentClient = null;
+    
     TreeNode currentNode = null;
 
@@ -254,5 +256,7 @@
       }
       tvClientControl.ExpandAll();
-    }
+      Thread.Sleep(5000);
+    }
+
 
     private void AddClientOrGroup(ClientGroup clientGroup, TreeNode currentNode) {
@@ -419,4 +423,5 @@
         pbJobControl.Image = ilLargeImgJob.Images[0];
       }
+
       lblJobName.Text = currentJob.Id.ToString();
       progressJob.Value = (int)(currentJob.Percentage * 100);