Index: trunk/sources/HeuristicLab.Hive.Server.Console/3.2/HiveServerManagementConsole.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Console/3.2/HiveServerManagementConsole.Designer.cs	(revision 1753)
+++ trunk/sources/HeuristicLab.Hive.Server.Console/3.2/HiveServerManagementConsole.Designer.cs	(revision 1774)
@@ -50,4 +50,7 @@
       this.pbUserControl = new System.Windows.Forms.PictureBox();
       this.plJobDetails = new System.Windows.Forms.Panel();
+      this.lvJobDetails = new System.Windows.Forms.ListView();
+      this.chContent = new System.Windows.Forms.ColumnHeader();
+      this.chDetails = new System.Windows.Forms.ColumnHeader();
       this.lvSnapshots = new System.Windows.Forms.ListView();
       this.chClientCalculated = new System.Windows.Forms.ColumnHeader();
@@ -82,4 +85,5 @@
       this.scClientControl = new System.Windows.Forms.SplitContainer();
       this.splitContainer1 = new System.Windows.Forms.SplitContainer();
+      this.btnRefresh = new System.Windows.Forms.Button();
       this.tvClientControl = new System.Windows.Forms.TreeView();
       this.lvClientControl = new System.Windows.Forms.ListView();
@@ -135,5 +139,5 @@
       this.refreshToolStripMenuItem.Size = new System.Drawing.Size(123, 22);
       this.refreshToolStripMenuItem.Text = "Refresh";
-      this.refreshToolStripMenuItem.Click += new System.EventHandler(this.refreshToolStripMenuItem_Click);
+      this.refreshToolStripMenuItem.Click += new System.EventHandler(this.Refresh_Click);
       // 
       // closeToolStripMenuItem
@@ -265,4 +269,5 @@
       // 
       this.lblClientName.AutoSize = true;
+      this.lblClientName.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
       this.lblClientName.Location = new System.Drawing.Point(41, 14);
       this.lblClientName.Name = "lblClientName";
@@ -321,4 +326,5 @@
       this.plJobDetails.BackColor = System.Drawing.SystemColors.Window;
       this.plJobDetails.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
+      this.plJobDetails.Controls.Add(this.lvJobDetails);
       this.plJobDetails.Controls.Add(this.lvSnapshots);
       this.plJobDetails.Controls.Add(this.lblPriorityJob);
@@ -341,4 +347,28 @@
       this.plJobDetails.Visible = false;
       // 
+      // lvJobDetails
+      // 
+      this.lvJobDetails.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
+            this.chContent,
+            this.chDetails});
+      this.lvJobDetails.FullRowSelect = true;
+      this.lvJobDetails.GridLines = true;
+      this.lvJobDetails.Location = new System.Drawing.Point(20, 129);
+      this.lvJobDetails.Name = "lvJobDetails";
+      this.lvJobDetails.Size = new System.Drawing.Size(375, 137);
+      this.lvJobDetails.TabIndex = 17;
+      this.lvJobDetails.UseCompatibleStateImageBehavior = false;
+      this.lvJobDetails.View = System.Windows.Forms.View.Details;
+      // 
+      // chContent
+      // 
+      this.chContent.Text = "Content";
+      this.chContent.Width = 121;
+      // 
+      // chDetails
+      // 
+      this.chDetails.Text = "Details";
+      this.chDetails.Width = 247;
+      // 
       // lvSnapshots
       // 
@@ -633,4 +663,5 @@
       // splitContainer1.Panel1
       // 
+      this.splitContainer1.Panel1.Controls.Add(this.btnRefresh);
       this.splitContainer1.Panel1.Controls.Add(this.tvClientControl);
       // 
@@ -642,10 +673,21 @@
       this.splitContainer1.TabIndex = 0;
       // 
+      // btnRefresh
+      // 
+      this.btnRefresh.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.btnRefresh.Image = ((System.Drawing.Image)(resources.GetObject("btnRefresh.Image")));
+      this.btnRefresh.Location = new System.Drawing.Point(0, 357);
+      this.btnRefresh.Name = "btnRefresh";
+      this.btnRefresh.Size = new System.Drawing.Size(151, 29);
+      this.btnRefresh.TabIndex = 1;
+      this.btnRefresh.UseVisualStyleBackColor = true;
+      this.btnRefresh.Click += new System.EventHandler(this.Refresh_Click);
+      // 
       // tvClientControl
       // 
-      this.tvClientControl.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.tvClientControl.Dock = System.Windows.Forms.DockStyle.Top;
       this.tvClientControl.Location = new System.Drawing.Point(0, 0);
       this.tvClientControl.Name = "tvClientControl";
-      this.tvClientControl.Size = new System.Drawing.Size(151, 386);
+      this.tvClientControl.Size = new System.Drawing.Size(151, 357);
       this.tvClientControl.TabIndex = 0;
       this.tvClientControl.NodeMouseClick += new System.Windows.Forms.TreeNodeMouseClickEventHandler(this.tvClientControl_NodeMouseClick);
@@ -788,6 +830,10 @@
     private System.Windows.Forms.ImageList ilSmallImgJob;
     private System.Windows.Forms.SplitContainer splitContainer1;
+    private System.Windows.Forms.ToolStripMenuItem refreshToolStripMenuItem;
+    private System.Windows.Forms.ListView lvJobDetails;
+    private System.Windows.Forms.ColumnHeader chContent;
+    private System.Windows.Forms.ColumnHeader chDetails;
+    private System.Windows.Forms.Button btnRefresh;
     private System.Windows.Forms.TreeView tvClientControl;
-    private System.Windows.Forms.ToolStripMenuItem refreshToolStripMenuItem;
   }
 }
Index: trunk/sources/HeuristicLab.Hive.Server.Console/3.2/HiveServerManagementConsole.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Console/3.2/HiveServerManagementConsole.cs	(revision 1753)
+++ trunk/sources/HeuristicLab.Hive.Server.Console/3.2/HiveServerManagementConsole.cs	(revision 1774)
@@ -410,4 +410,5 @@
     private void JobClicked() {
       plJobDetails.Visible = true;
+      lvJobDetails.Items.Clear();
       int i = 0;
       while (jobs.List[i].Id.ToString() != nameCurrentJob) {
@@ -424,18 +425,56 @@
       }
 
+
+
       lblJobName.Text = currentJob.Id.ToString();
       progressJob.Value = (int)(currentJob.Percentage * 100);
       lblProgress.Text = (int)(currentJob.Percentage * 100) + "% calculated";
       lblUserCreatedJob.Text = currentJob.UserId.ToString() + /* currentJob.User.Name + */ " created Job";
-      lblJobCreated.Text = "Created at " + currentJob.DateCreated;
+      //lblJobCreated.Text = "Created at " + currentJob.DateCreated;
+      ListViewItem lvi = new ListViewItem();
+      lvi.Text = "User:";
+      lvi.SubItems.Add(currentJob.UserId.ToString());
+      lvJobDetails.Items.Add(lvi);
+
+        lvi = null;
+        lvi = new ListViewItem();
+        lvi.Text = "created at:";
+        lvi.SubItems.Add(currentJob.DateCreated.ToString());
+        lvJobDetails.Items.Add(lvi);
+
       if (currentJob.ParentJob != null) {
-        lblParentJob.Text = currentJob.ParentJob.Id + " is parent job";
-      } else {
-        lblParentJob.Text = "";
-      }
-      lblPriorityJob.Text = "Priority of job is " + currentJob.Priority;
+        lvi = null;
+        lvi = new ListViewItem();
+        lvi.Text = "Parent job:";
+        lvi.SubItems.Add(currentJob.ParentJob.ToString());
+        lvJobDetails.Items.Add(lvi);
+     // lblParentJob.Text = currentJob.ParentJob.Id + " is parent job";
+      }// else {
+      //  lblParentJob.Text = "";
+      //}
+
+      lvi = null;
+      lvi = new ListViewItem();
+      lvi.Text = "Priority:";
+      lvi.SubItems.Add(currentJob.Priority.ToString());
+      lvJobDetails.Items.Add(lvi);
+
+     // lblPriorityJob.Text = "Priority of job is " + currentJob.Priority;
       if (currentJob.Client != null) {
-        lblClientCalculating.Text = currentJob.Client.Name + " calculated Job";
-        lblJobCalculationBegin.Text = "Startet calculation at " + currentJob.DateCalculated;
+        lvi = null;
+        lvi = new ListViewItem();
+        lvi.Text = "Calculation begin:";
+        lvi.SubItems.Add(currentJob.DateCalculated.ToString());
+        lvJobDetails.Items.Add(lvi);
+
+
+        lvi = null;
+        lvi = new ListViewItem();
+        lvi.Text = "Client calculated:";
+        lvi.SubItems.Add(currentJob.Client.Name.ToString());
+        lvJobDetails.Items.Add(lvi);
+
+        //lblClientCalculating.Text = currentJob.Client.Name + " calculated Job";
+        //lblJobCalculationBegin.Text = "Startet calculation at " + currentJob.DateCalculated;
 
         if (currentJob.State == State.finished) {
@@ -443,10 +482,16 @@
             ServiceLocator.GetJobManager();
           ResponseObject<JobResult> jobRes = jobManager.GetLastJobResultOf(currentJob.Id, false);
-          lblJobCalculationEnd.Text = "Calculation ended at " + jobRes.Obj.DateFinished;
+          
+          lvi = null;
+          lvi = new ListViewItem();
+          lvi.Text = "Calculation ended:";
+          lvi.SubItems.Add(jobRes.Obj.DateFinished.ToString());
+          lvJobDetails.Items.Add(lvi);
+         // lblJobCalculationEnd.Text = "Calculation ended at " + jobRes.Obj.DateFinished;
         }
       } else {
-        lblClientCalculating.Text = "";
-        lblJobCalculationBegin.Text = "";
-        lblJobCalculationEnd.Text = "";
+       // lblClientCalculating.Text = "";
+       // lblJobCalculationBegin.Text = "";
+       // lblJobCalculationEnd.Text = "";
       }
       if (currentJob.State != State.offline) {
@@ -912,6 +957,31 @@
     }
 
-    private void refreshToolStripMenuItem_Click(object sender, EventArgs e) {
+    private void Refresh_Click(object sender, EventArgs e) {
+      Form overlayingForm = new Form();
+      //Label loadingLabel = new Label();
+      //loadingLabel.Text = "Loading";
+      //loadingLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 20F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
+      //loadingLabel.Location = new Point(this.Width / 2, this.Height / 2);
+      //overlayingForm.Controls.Add(loadingLabel);
+
+
+      overlayingForm.Show();
+      overlayingForm.FormBorderStyle = FormBorderStyle.None;
+      overlayingForm.BackColor = Color.Gray;
+      overlayingForm.Opacity = 0.4;
+      overlayingForm.Size = this.Size;
+      //overlayingForm.PointToClient(new Point(this.Left, this.Top));
+      overlayingForm.Location = this.Location;
+      Console.WriteLine(this.Left + ", " + this.Top);
+      //overlayingForm.Left = this.Left;
+      //overlayingForm.Top = this.Top;
+
+      
+      
+
+
       AddClients();
+
+      overlayingForm.Close();
     }
   }
Index: trunk/sources/HeuristicLab.Hive.Server.Console/3.2/HiveServerManagementConsole.resx
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Console/3.2/HiveServerManagementConsole.resx	(revision 1753)
+++ trunk/sources/HeuristicLab.Hive.Server.Console/3.2/HiveServerManagementConsole.resx	(revision 1774)
@@ -308,4 +308,27 @@
     <value>462, 9</value>
   </metadata>
+  <assembly alias="System.Drawing" name="System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
+  <data name="btnRefresh.Image" type="System.Drawing.Bitmap, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
+    <value>
+        iVBORw0KGgoAAAANSUhEUgAAABgAAAAYCAYAAADgdz34AAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8
+        YQUAAAAgY0hSTQAAeiYAAICEAAD6AAAAgOgAAHUwAADqYAAAOpgAABdwnLpRPAAAAAlwSFlzAABcQwAA
+        XEMBOS4mtwAAA5dJREFUSEullslPU1EUxtVVSyeGoOgWYWViomGB0YUbE7fGxODGuPEfMHFjgpowaDQy
+        KlAHlKlMKoNQKQomFUShDEKhtLSlkcgkiAMz9POcR1/7HlBotMmX3td77/m9c86953QvgD3ST2qrMo6e
+        E0iHSftkk8EfvDQ1Quq8fnrRIVvGAFZKiyKGVEsCK/29AvfMypDEa8V9Phsxol3R+EGamEhtVcDQr4N5
+        LBqW6QPono4JSbyW9/BetsG2SAeF6Pjevj6NJprdUWj7Fo2m0UjUO8NR51O9MwKvXRFocAdkpLFxdEMm
+        TyRax6LQPh4NE9lgWwSoFwA0iGf3DANa1I6Eo2hAjef9ahQPaFBi1aB0UIMykmFIiwqbFpXDG6omvbDr
+        8NKhwytSzYgOtfRCJk8Eyvq1YsjiGZDEbvGGwi9qPCPjDPgfiNEdLoYqiQHJGW1KPOlTC9oNUm7TkQes
+        gCefxi+h2XNc5klmu5K9SGbAzdxPSjzuVe0IMbnPYHLejDXvPNa9S5hdtKBn6hrsP3Ip1MA7zylZuPQW
+        FQNuCIAcAuh7VEEhH8auCEZ2+rz1nJTl5FF3WACQ3aFEQbdqW0idIxG/lp3ombyFJtcZ1DqOonPiKrxY
+        lfGaCSBNvN4iAWQRIN8HeCQJ1VNKeoPzNJ2mKCHpRb6TZf1+f4szDKiSnKwCOUAhAIJBpCerxXMec8tD
+        +Lk8LOjXigO/V5x4M5ogJF6EyACZHQrkEVGElAzEUkhuo3fyDn2nk9LQO5VGITor84TvCIvvSLnkjjCk
+        oEsSosyPCjwggAiptp3YEoLphS4K1X7/HeFwVdgOCYDtIPmbAbn0gwjZDOCE1tgTwTnhcNXYj8E2o4f5
+        62X/bd8MkQEyyAMGiJCqocQtHqx7lzGz2IeF1Qlhzj1XLSRdTPxmT2SA++0K5HRuAFiVPsCPJRsm/nTI
+        YF6swTqdg2Jr5I4lJY/siRct+a5ZgazPSj+kYjARjtlKunjRQuIN1iMwuS5Qks/BMBgbUknJkJSKpBQq
+        drmdAUhet07w5KEk8cEu4vbFUQ22yYXUX67zCJBNXkg9+RdIiVUNvcXf4eL9DYdLdml/GAr7+DQFwhUq
+        pJj6SMWQGuVWlViqNxqOr6P5W+ZjqoI1wxoYXRoqE1q/Gmnc6JLLSM+sJrcGdXYNnlC+tm2ZwZr+XWr6
+        rN2a/65NX/wH4APFUXIucrPgUh6ieC3viZPa4vFfU36gB1Ssto8AAAAASUVORK5CYII=
+</value>
+  </data>
   <metadata name="contextMenuJob.TrayLocation" type="System.Drawing.Point, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a">
     <value>252, 44</value>