Index: trunk/sources/HeuristicLab.Hive.Client.Common/3.2/Logging.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Client.Common/3.2/Logging.cs	(revision 1774)
+++ trunk/sources/HeuristicLab.Hive.Client.Common/3.2/Logging.cs	(revision 1775)
@@ -77,5 +77,6 @@
     public void Error(String source, String message) {
       eventLogger.Source = source;
-      eventLogger.WriteEntry(message, EventLogEntryType.Error);
+      //, EventLogEntryType.Error
+      eventLogger.WriteEntry(message);
       eventLogger.Close();
     }
@@ -89,5 +90,5 @@
     public void Error(String source, String message, Exception e) {
       eventLogger.Source = source;
-      eventLogger.WriteEntry(message +"\n" + e.ToString(), EventLogEntryType.Error);
+      eventLogger.WriteEntry(message +"\n" + e.ToString());
       eventLogger.Close();
     }
Index: trunk/sources/HeuristicLab.Hive.Client.Common/3.2/MessageQueue.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Client.Common/3.2/MessageQueue.cs	(revision 1774)
+++ trunk/sources/HeuristicLab.Hive.Client.Common/3.2/MessageQueue.cs	(revision 1775)
@@ -51,4 +51,12 @@
 
     /// <summary>
+    /// Sets Lease time to infinite
+    /// </summary>
+    /// <returns>nothing</returns>
+    public override object InitializeLifetimeService() {
+      return null;
+    }
+
+    /// <summary>
     /// Creates a new MessageQueue Object.
     /// A new Queue and a Semaphore is created. The Semaphore is set to a max size of 5000.
Index: trunk/sources/HeuristicLab.Hive.Client.Core/3.2/Core.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Client.Core/3.2/Core.cs	(revision 1774)
+++ trunk/sources/HeuristicLab.Hive.Client.Core/3.2/Core.cs	(revision 1775)
@@ -118,5 +118,12 @@
         //Job has been successfully aborted
         case MessageContainer.MessageType.JobAborted:
-          Debug.WriteLine("-- Job Aborted Message received");
+          //todo: thread this
+          Debug.WriteLine("Job aborted, he's dead");
+          lock (engines) {
+            AppDomain.Unload(appDomains[container.JobId]);
+            appDomains.Remove(container.JobId);
+            engines.Remove(container.JobId);
+            jobs.Remove(container.JobId);
+          }
           break;
         //Request a Snapshot from the Execution Engine
@@ -132,5 +139,5 @@
           if (!currentlyFetching) {
             wcfService.SendJobAsync(ConfigManager.Instance.GetClientInfo().Id);
-            currentlyFetching = false;
+            currentlyFetching = true;
           }          
           break;          
@@ -212,6 +219,6 @@
         //Todo: make a set & override the equals method
         List<byte[]> files = new List<byte[]>();
-        foreach (CachedHivePluginInfo plugininfo in PluginCache.Instance.GetPlugins(e.Result.Job.PluginsNeeded))
-          files.AddRange(plugininfo.PluginFiles);
+        //foreach (CachedHivePluginInfo plugininfo in PluginCache.Instance.GetPlugins(e.Result.Job.PluginsNeeded))
+        //  files.AddRange(plugininfo.PluginFiles);
         
         AppDomain appDomain = PluginManager.Manager.CreateAndInitAppDomainWithSandbox(e.Result.Job.Id.ToString(), sandboxed, null, files);
@@ -232,6 +239,7 @@
             Debug.WriteLine("Increment FetchedJobs to:" + ClientStatusInfo.JobsFetched);
           }
-        }
-      }
+        }        
+      }
+      currentlyFetching = false;
     }
     
Index: trunk/sources/HeuristicLab.Hive.Client.Core/3.2/JobStorage/JobStorageManager.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Client.Core/3.2/JobStorage/JobStorageManager.cs	(revision 1774)
+++ trunk/sources/HeuristicLab.Hive.Client.Core/3.2/JobStorage/JobStorageManager.cs	(revision 1775)
@@ -9,4 +9,5 @@
 using HeuristicLab.Hive.Contracts;
 using System.Xml.Serialization;
+using System.Diagnostics;
 
 namespace HeuristicLab.Hive.Client.Core.JobStorage {
@@ -16,5 +17,5 @@
     //Todo: execution path
     //Todo: Choose a better directory name 
-    private static String path = "C:\\Program Files\\HeuristicLab 3.0\\plugins\\jobStorrage\\";
+    private static String path = "C:\\Program Files\\HeuristicLab 3.0\\plugins\\Hive.Client.Jobs\\";
     
     public static void PersistObjectToDisc(String serverIP, long serverPort, Guid jobId, byte[] job) {
@@ -30,5 +31,6 @@
         jobstream.Write(job, 0, job.Length);
         storedJobsList.Add(info);
-        Logging.Instance.Info("JobStorageManager", "Job " + info.JobID + " stored on the harddisc");
+        Debug.WriteLine("Job " + info.JobID + " stored on the harddisc");
+        //Logging.Instance.Info("JobStorageManager", "Job " + info.JobID + " stored on the harddisc");
       }
       catch (Exception e) {
@@ -48,12 +50,16 @@
         if (WcfService.Instance.ConnState == NetworkEnum.WcfConnState.Loggedin && (storedJobsList[index-1].ServerIP == WcfService.Instance.ServerIP && storedJobsList[index-1].ServerPort == WcfService.Instance.ServerPort)) {
           String filename = storedJobsList[index-1].ServerIP + "." + storedJobsList[index-1].ServerPort + "." + storedJobsList[index-1].JobID.ToString();
-          Logging.Instance.Info("JobStorrageManager", "Sending stored job " + storedJobsList[index - 1].JobID + " to the server");
+          Debug.WriteLine("Sending stored job " + storedJobsList[index - 1].JobID + " to the server");
+          //Logging.Instance.Info("JobStorrageManager", "Sending stored job " + storedJobsList[index - 1].JobID + " to the server");
           byte[] job = File.ReadAllBytes(path + filename + ".dat");
           
           //Todo: ask server first if he really wants the job...
           ResponseResultReceived res = WcfService.Instance.SendStoredJobResultsSync(ConfigManager.Instance.GetClientInfo().Id, storedJobsList[index-1].JobID, job, 1.00, null, true);
+          ClientStatusInfo.JobsProcessed++;
           //TODO: has to be fixed from server side
           //if (res.Success == true) {
-          Logging.Instance.Info("JobStorrageManager", "Sending of job " + storedJobsList[index - 1].JobID + " done");  
+          Debug.WriteLine("Sending of job " + storedJobsList[index - 1].JobID + " done");  
+          //Logging.Instance.Info("JobStorrageManager", "Sending of job " + storedJobsList[index - 1].JobID + " done");  
+
           storedJobsList.Remove(storedJobsList[index - 1]);
           File.Delete(path + filename + ".dat");
@@ -66,6 +72,7 @@
     public static void StoreJobList() {
       XmlSerializer serializer = new XmlSerializer(typeof(List<JobStorageInfo>));
-      TextWriter writer = new StreamWriter(path + "list.xml");
+      TextWriter writer = new StreamWriter(Path.Combine(path ,"list.xml"));
       serializer.Serialize(writer, storedJobsList);
+      writer.Close();
     }
     